=== modified file 'apt-pkg/contrib/strutl.cc'
--- apt-pkg/contrib/strutl.cc	
+++ apt-pkg/contrib/strutl.cc	
@@ -1165,6 +1165,24 @@
    return Res;
 }
 									/*}}}*/
+// URI::empty - Determine whether a URI is filled in or not		/*{{{*/
+// ---------------------------------------------------------------------
+/* */
+bool URI::empty()
+{
+   if (Access.empty())
+       return true;
+   else if (Host.empty())
+   {
+       if (Access != "file" && Access != "copy")
+           return true;
+           // methods that aren't allowed to have empty Host fields:
+           // http, ftp, cdrom, rsh, ssh.
+   }
+   return false;
+}
+
+									/*}}}*/
 // URI::SiteOnly - Return the schema and site for the URI		/*{{{*/
 // ---------------------------------------------------------------------
 /* */

=== modified file 'apt-pkg/contrib/strutl.h'
--- apt-pkg/contrib/strutl.h	
+++ apt-pkg/contrib/strutl.h	
@@ -114,7 +114,7 @@
    
    operator string();
    inline void operator =(const string &From) {CopyFrom(From);};
-   inline bool empty() {return Access.empty();};
+   bool empty();
    static string SiteOnly(const string &URI);
    
    URI(string Path) {CopyFrom(Path);};

